#include "mymath.h"
#include "myassert.h"

#include "global.h"

extern double RUNNING_STEP;
extern double RADIUS;
extern double MUTATION_RATE;

class crab {
  private:
	double dx;  // X component of unit direction vector
	double dy;  // Y component of unit direction vector
	double dz;  // Z component of unit direction vector
	double xcor; // X component of position
	double ycor; // Y component of position
	double zcor; // Z component of position
	//double heading; // An angle in radians

	// gene1 is a parameter used in weighting the location of others
	// when deciding where to flee to.
	double gene1;

	void wrap_coordinates(void);
	double angle(double dx, double dy);
	inline double min(double x, double y);
	inline double min_mag(double x, double y);
	inline double min_mag(double x, double y, double z);
  public:
	crab();
	crab(double g);
	~crab();
	
	double set_gene1(double x);
	double set_gene2(double x);

	double get_x(void);
	double get_y(void);
	double get_z(void);
	double get_gene1(void);

	void reset_galileon(void);
	void walk_forward(double distance);
	void think_about_herd(crab* (herd_pointer[]), const int current_crab, const int NUMBER);
	void flight_manuever(crab* (herd_pointer[]));
};
