double RUNNING_STEP		= 0.0;
double RADIUS			= 2.0;
double MUTATION_RATE		= 0.0;
//double *DISTANCE_MATRIX;

double min_mag(double x, double y, double z) {
	x = (fabs(x) < fabs(y)) ? x : y;
	x = (fabs(x) < fabs(z)) ? x : z;
	return x;
}

double random_mutation_multiple(const double x) {
	// random drift, with a constant coefficient of variation
	// a uniform distribution on [ -a/2, a/2] has variance a^2/12
	//allele = allele * ( 1.0 + (uniform_random() - 0.500) * MUTATION_RATE);
	//double y = ( 1.0 + (uniform_random() - 0.500) * MUTATION_RATE/12);
	//	This drift method is strongly biased downwards, 
	//	and thus should be avoided!

	///////////////////////////////
	//  The math of calculating the equilibrium behavior was too complicated
	//  with the above mutation model.  This one is slower but simplier.
	//  Since the exponential drift term has a non-zero expectation,
	//  we have to adjust for it, by dividing by the expect value sinh(m)/m.
	//double y = exp( (2.0 * uniform_random()-1.0-MUTATION_RATE/6.0) * MUTATION_RATE);

	// Attempt to explicitly adjust for the mean
	//double mean = sinh(MUTATION_RATE)/MUTATION_RATE;
	//double y = exp( (2.0*uniform_random()-1.0) * MUTATION_RATE)/mean;
	
	while ( true ) {
		double y = x*exp( (2.0*uniform_random()-1.0) * MUTATION_RATE);
		if ( y > GENE1_MIN && y < GENE1_MAX ) return y;
	}
}
