//#include "mymath.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <iostream>
#include <iomanip>
#include "myassert.h"


//Quick sorting: p and q serve as indexes into the array
//being sorted.  T is the class.  A is an array of pointers
//to the class, which has an well-ordering imposed.
template<class T>
void quicksort(T* A[], long p, long r) {
        long q;
        if (p<r) {
                q = partition(A,p,r);
                quicksort(A,p,q);
                quicksort(A,q+1,r);
        }
        return;
}

// This is a function internal to quicksort, and
// never should be called by itself.
template<class T>
inline long partition(T* A[], long p, long r) {
        T* x1 = A[p];
        T* x2;
        p--; r++;
        while (true) {
                for (p++; *A[p] > *x1; p++);
                for (r--; *A[r] < *x1; r--);
                if (p<r) {
                        x2 = A[p];
                        A[p] = A[r];
                        A[r] = x2;
                } else return r;
        }
}

template<class T>
inline T* max(T* a, T* b) {
	if (*a > *b) return a;
	return b;
}

template<class T>
inline T* min(T* a, T* b) {
	if (*a > *b) return b;
	return a;
}

long sign(long x) {
	if (x<0) return -1;
	else if (x>0) return 1;
	else return 0;
}

double heavyside(double x) {
	if (x <0.0) return 0.0;
	else if (x > 0.0) return 1.0;
	else return 0.5;
}

int factorial(int x) {
	int fval;
	fval = 1;
	while (x >0) {
		fval = fval * x;
		x--;
	}
	return(fval);
}

int gcd(int p, int q) {
	int x;
	if (p < q) { x = p; p = q; q = x ;}
	for (; x = p % q; ) {
		p = q;
		q = x;
	}
	return q;
}

double nCr(double n, double r) {
        double rval=1;
        int x = int(n);
        int y = int(r);
        for (int i = x; i>x-y; i--) rval*=double(i);
        for (int i = y; i>1; i--) rval = rval/double(i);
        return(rval);
}

double binomial(double n, double r, double p) {
        double rval = 1;
        int N = int(n);
        int R = int(r);
        rval = nCr(n,r) * pow(p,R) * pow(1-p,N-R);
        return rval;
}

double poisson(double x, double lambda) {
	double rval=0;
	double x_factorial = double(factorial(int(x)));
	rval = exp(-lambda)* pow(lambda,x)/x_factorial;
	return rval;
}

double uniform_random(void) {
        return double(random())/double(RAND_MAX);
}

int	int_random(int max) {
        double x = double(max)*(double(random())/double(RAND_MAX));
	return int(x);
	/*
	int x = max;
	while ( x >= max || x < 0 ) {
		x = int( double(max)*uniform_random() );
	}
	return x;
	*/
}
bool bool_random(double p) {
	return (p > uniform_random()) ? true : false;
}

unsigned int getrandomseed(void) {
	unsigned int seed;
	FILE *fp;

	Assert( (fp = fopen("/dev/random", "r")) != NULL, "Can't open /dev/random for reading.");
	fread(&seed, sizeof(unsigned int), 1, fp);
	fclose(fp);
	return seed;
}
